import { system, world } from '@minecraft/server';

function durabilityOnChanged(item, player, isHitEntity = false) {
    let level = item.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level;

    function durability() {
        let durability = item.getComponent("minecraft:durability");

        const t = Math.floor(Math.random() * 100);

        if (t < durability.getDamageChance()) {
            if (!isHitEntity) durability.damage += 1;
            if (durability.damage >= durability.maxDurability) {
                player.playSound("random.break");
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', undefined)
            } else {
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item)
            }
        } else {
            if (!isHitEntity) return;
            durability.damage -= 1;
            if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }

    const t = Math.floor(Math.random() * 10)
    if (level === 1 && t > 8) return;
    else if (level === 2 && t > 6) return;
    else if (level === 3 && t > 4) return;
    else durability();
}

world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_summon:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_BASICA"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_bronze_moto_body:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_BASICA"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_b:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_B"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_r:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_R"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_g:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_Gray"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_lime:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_lime"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_purple:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_purple"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_o:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_orange"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_p:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_pink"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_magenta:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_magenta"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_yellow:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_yellow"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_cyan:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_cyan"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_light_gray:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_light_gray"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_brown:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_brown"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_light_blue:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_light_blue"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_w:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_white"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_green:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_green"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_motorcycle_blak:trigger', {
  onUse: e => { e.source.runCommand("function INVOCAR_MOTO_black"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_car_summon:trigger', {
  onUse: e => { e.source.runCommand("function invocar_carro"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_car_summon_diamond:trigger', {
  onUse: e => { e.source.runCommand("function invocar_carro_diamante"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_car_summon_amethyst:trigger', {
  onUse: e => { e.source.runCommand("function invocar_carro_amatista"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_basic_car_summon_gold:trigger', {
  onUse: e => { e.source.runCommand("function invocar_carro_oro"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_echo_sword:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); e.attackingEntity.runCommand("function echo_attack_1"); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_levi_car_no_engine:trigger', {
  onUse: e => { e.source.runCommand("function invocar_drifter_hierro"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_levi_car_redstone_engine:trigger', {
  onUse: e => { e.source.runCommand("function invocar_drifter_redstone"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_levi_car_emerald_engine:trigger', {
  onUse: e => { e.source.runCommand("function invocar_drifter_emerald"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_levi_car_echo_engine:trigger', {
  onUse: e => { e.source.runCommand("function invocar_drifter_sonic"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_red:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_green:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_blue:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_yellow:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_lime:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_orange:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_pink:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_light_blue:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_light_gray:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_brown:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_gray:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_purple:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_magenta:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_cyan:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('pa_amethyts_sword_black:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function amethyst_power_1"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});
 });
